/*
   This program parses and evaluates strings from Language_6a.
*/

public class Language_6a_Examples
{
   public static void main(String[] args)
   {
      String[] programs =
      {
         "( for ( var i 1 ) ( <= i 4 ) ( set i ( + i 2 ) ) " +
             "( print i ) ) ",

         "( prog " +
             "( var i 0 ) " +
             "( for ( set i 1 ) ( <= i 4 ) ( set i ( + i 1 ) ) " +
                 "( print i ) ) " +
             "( print i ) )",

         "( prog " +
             "( var i 0 ) " +
             "( for ( var i 1 ) ( <= i 4 ) ( set i ( + i 1 ) ) " +
                 "( print i ) ) " +
             "( print i ) )",

         "( prog " +
             "( var i 0 ) " +
             "( for ( var i 0 ) ( < i 3 ) ( set i ( + i 1 ) ) " +
                 "( begin " +
                    "( var i 0 ) " +
                    "( print i ) ) ) )",

         "( prog " +
             "( for ( var i 1 ) ( <= i 5 ) ( set i ( + i 1 ) ) " +
                 "( print i ) ) " +
             "( print i ) )",

         "( prog " +
             "( var n 8 ) " +  // compute n!
             "( for ( var i ( - n 1 ) ) ( > i 0 ) ( set i ( - i 1 ) ) " +
                 "( set n ( * i n ) ) ) " +
             "( print n ) )",

         "( prog " +
             "( var n 420135 ) " +  // reverse the digits of n
             "( print n ) " +
             "( var m 0 ) " +
             "( for ( var d 0 ) ( > n 0 ) ( set n ( / ( - n d ) 10 ) ) " +
                 "( begin " +
                    "( set d ( % n 10 ) ) " +
                    "( set m ( + ( * 10 m ) d ) ) " +
                    "( print m ) ) ) " +
              "( print m ) )"
      };


      // Create a Language_6a object (which implements the interpreter).
      Language_6a interpreter = new Language_6a();


      int i = 0;
      for (i = 0; i < programs.length; i++)
      {
         System.out.println(i + " =============================================");

         // Print the expression.
         //System.out.println( programs[i] + "\n" );

         // Build the abstract syntax tree that represents the expression.
         try
         {
            Tree ast = BuildTree.buildTree( programs[i] );

            // Print the AST as an S-expression
            System.out.println( ast + "\n" );

            // Pretty-print the abstract syntax tree.
            System.out.println( PrettyPrinter2.prettyPrint( ast ) + "\n" );

            // Print the infix version of the expression.
            System.out.println( AST2infix_6a.ast2infix( ast ) + "\n" );

            // Evaluate the expression (interpret the AST).
            try
            {
               Value value = interpreter.eval( ast );
               System.out.println( "result = " + value + "\n" );
            }
            catch (EvalException e)
            {
               System.out.println(e);
             //e.printStackTrace();
            }


            // Create dot and png files from the AST.
            if(true)
            try
            {
               // Create the (empty) dot file.
               String baseName = String.format("Language_6a.%02d", i);
               java.io.PrintWriter out = new java.io.PrintWriter(
                                            new java.io.File(baseName + ".dot") );
               // Put dot commands into the dot file
               out.println( Tree2dot_ver1.tree2dot(ast) + "\n" );
               out.close();
               // Create a command line for running dot.exe.
               String[] cmd = {"C:\\graphviz-2.38\\release\\bin\\dot.exe",
                               "-Tpng",
                               baseName + ".dot",
                               "-o",
                               baseName + ".png"};
               // Execute the command line.
               java.lang.Runtime.getRuntime().exec(cmd);
            }
            catch (Exception e)
            {
               System.out.println( e );
            }
         }
         catch (ParseException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
      }
   }//main
}
